# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

module Google
  module Compute
    module Data
      # A class to manage data for Deprecated for disk_type.
      class DiskTypeDeprecated
        include Comparable

        attr_reader :deleted
        attr_reader :deprecated
        attr_reader :obsolete
        attr_reader :replacement
        attr_reader :state

        def to_json(_arg = nil)
          {
            'deleted' => deleted,
            'deprecated' => deprecated,
            'obsolete' => obsolete,
            'replacement' => replacement,
            'state' => state
          }.reject { |_k, v| v.nil? }.to_json
        end

        def to_s
          {
            deleted: deleted.to_s,
            deprecated: deprecated.to_s,
            obsolete: obsolete.to_s,
            replacement: replacement.to_s,
            state: state.to_s
          }.map { |k, v| "#{k}: #{v}" }.join(', ')
        end

        def ==(other)
          return false unless other.is_a? DiskTypeDeprecated
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            return false if compare[:self] != compare[:other]
          end
          true
        end

        def <=>(other)
          return false unless other.is_a? DiskTypeDeprecated
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            result = compare[:self] <=> compare[:other]
            return result unless result.zero?
          end
          0
        end

        def inspect
          to_json
        end

        private

        def compare_fields(other)
          [
            { self: deleted, other: other.deleted },
            { self: deprecated, other: other.deprecated },
            { self: obsolete, other: other.obsolete },
            { self: replacement, other: other.replacement },
            { self: state, other: other.state }
          ]
        end
      end

      # Manages a DiskTypeDeprecated nested object
      # Data is coming from the GCP API
      class DiskTypeDeprecatedApi < DiskTypeDeprecated
        def initialize(args)
          @deleted = Google::Compute::Property::Time.api_parse(args['deleted'])
          @deprecated = Google::Compute::Property::Time.api_parse(args['deprecated'])
          @obsolete = Google::Compute::Property::Time.api_parse(args['obsolete'])
          @replacement = Google::Compute::Property::String.api_parse(args['replacement'])
          @state = Google::Compute::Property::Enum.api_parse(args['state'])
        end
      end

      # Manages a DiskTypeDeprecated nested object
      # Data is coming from the Chef catalog
      class DiskTypeDeprecatedCatalog < DiskTypeDeprecated
        def initialize(args)
          @deleted = Google::Compute::Property::Time.catalog_parse(args[:deleted])
          @deprecated = Google::Compute::Property::Time.catalog_parse(args[:deprecated])
          @obsolete = Google::Compute::Property::Time.catalog_parse(args[:obsolete])
          @replacement = Google::Compute::Property::String.catalog_parse(args[:replacement])
          @state = Google::Compute::Property::Enum.catalog_parse(args[:state])
        end
      end
    end

    module Property
      # A class to manage input to Deprecated for disk_type.
      class DiskTypeDeprecated
        def self.coerce
          ->(x) { ::Google::Compute::Property::DiskTypeDeprecated.catalog_parse(x) }
        end

        # Used for parsing Chef catalog
        def self.catalog_parse(value)
          return if value.nil?
          return value if value.is_a? Data::DiskTypeDeprecated
          Data::DiskTypeDeprecatedCatalog.new(value)
        end

        # Used for parsing GCP API responses
        def self.api_parse(value)
          return if value.nil?
          return value if value.is_a? Data::DiskTypeDeprecated
          Data::DiskTypeDeprecatedApi.new(value)
        end
      end
    end
  end
end
