# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/compute/property/array'
module Google
  module Compute
    module Data
      # A class to manage data for GuestOsFeatures for image.
      class ImageGuestOsFeatures
        include Comparable

        attr_reader :type

        def to_json(_arg = nil)
          {
            'type' => type
          }.reject { |_k, v| v.nil? }.to_json
        end

        def to_s
          {
            type: type.to_s
          }.map { |k, v| "#{k}: #{v}" }.join(', ')
        end

        def ==(other)
          return false unless other.is_a? ImageGuestOsFeatures
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            return false if compare[:self] != compare[:other]
          end
          true
        end

        def <=>(other)
          return false unless other.is_a? ImageGuestOsFeatures
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            result = compare[:self] <=> compare[:other]
            return result unless result.zero?
          end
          0
        end

        def inspect
          to_json
        end

        private

        def compare_fields(other)
          [
            { self: type, other: other.type }
          ]
        end
      end

      # Manages a ImageGuestOsFeatures nested object
      # Data is coming from the GCP API
      class ImageGuestOsFeaturesApi < ImageGuestOsFeatures
        def initialize(args)
          @type = Google::Compute::Property::Enum.api_parse(args['type'])
        end
      end

      # Manages a ImageGuestOsFeatures nested object
      # Data is coming from the Chef catalog
      class ImageGuestOsFeaturesCatalog < ImageGuestOsFeatures
        def initialize(args)
          @type = Google::Compute::Property::Enum.catalog_parse(args[:type])
        end
      end
    end

    module Property
      # A class to manage input to GuestOsFeatures for image.
      class ImageGuestOsFeatures
        def self.coerce
          ->(x) { ::Google::Compute::Property::ImageGuestOsFeatures.catalog_parse(x) }
        end

        # Used for parsing Chef catalog
        def self.catalog_parse(value)
          return if value.nil?
          return value if value.is_a? Data::ImageGuestOsFeatures
          Data::ImageGuestOsFeaturesCatalog.new(value)
        end

        # Used for parsing GCP API responses
        def self.api_parse(value)
          return if value.nil?
          return value if value.is_a? Data::ImageGuestOsFeatures
          Data::ImageGuestOsFeaturesApi.new(value)
        end
      end

      # A Chef property that holds an integer
      class ImageGuestOsFeaturesArray < Google::Compute::Property::Array
        def self.coerce
          ->(x) { ::Google::Compute::Property::ImageGuestOsFeaturesArray.catalog_parse(x) }
        end

        # Used for parsing Chef catalog
        def self.catalog_parse(value)
          return if value.nil?
          return ImageGuestOsFeatures.catalog_parse(value) \
            unless value.is_a?(::Array)
          value.map { |v| ImageGuestOsFeatures.catalog_parse(v) }
        end

        # Used for parsing GCP API responses
        def self.api_parse(value)
          return if value.nil?
          return ImageGuestOsFeatures.api_parse(value) \
            unless value.is_a?(::Array)
          value.map { |v| ImageGuestOsFeatures.api_parse(v) }
        end
      end
    end
  end
end
