# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/compute/property/array'
module Google
  module Compute
    module Data
      # A class to manage data for Tests for url_map.
      class UrlMapTests
        include Comparable

        attr_reader :description
        attr_reader :host
        attr_reader :path
        attr_reader :service

        def to_json(_arg = nil)
          {
            'description' => description,
            'host' => host,
            'path' => path,
            'service' => service
          }.reject { |_k, v| v.nil? }.to_json
        end

        def to_s
          {
            description: description.to_s,
            host: host.to_s,
            path: path.to_s,
            service: service.to_s
          }.map { |k, v| "#{k}: #{v}" }.join(', ')
        end

        def ==(other)
          return false unless other.is_a? UrlMapTests
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            return false if compare[:self] != compare[:other]
          end
          true
        end

        def <=>(other)
          return false unless other.is_a? UrlMapTests
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            result = compare[:self] <=> compare[:other]
            return result unless result.zero?
          end
          0
        end

        def inspect
          to_json
        end

        private

        def compare_fields(other)
          [
            { self: description, other: other.description },
            { self: host, other: other.host },
            { self: path, other: other.path },
            { self: service, other: other.service }
          ]
        end
      end

      # Manages a UrlMapTests nested object
      # Data is coming from the GCP API
      class UrlMapTestsApi < UrlMapTests
        def initialize(args)
          @description = Google::Compute::Property::String.api_parse(args['description'])
          @host = Google::Compute::Property::String.api_parse(args['host'])
          @path = Google::Compute::Property::String.api_parse(args['path'])
          @service = Google::Compute::Property::BackendServiceSelfLinkRef.api_parse(args['service'])
        end
      end

      # Manages a UrlMapTests nested object
      # Data is coming from the Chef catalog
      class UrlMapTestsCatalog < UrlMapTests
        def initialize(args)
          @description = Google::Compute::Property::String.catalog_parse(args[:description])
          @host = Google::Compute::Property::String.catalog_parse(args[:host])
          @path = Google::Compute::Property::String.catalog_parse(args[:path])
          @service =
            Google::Compute::Property::BackendServiceSelfLinkRef.catalog_parse(args[:service])
        end
      end
    end

    module Property
      # A class to manage input to Tests for url_map.
      class UrlMapTests
        def self.coerce
          ->(x) { ::Google::Compute::Property::UrlMapTests.catalog_parse(x) }
        end

        # Used for parsing Chef catalog
        def self.catalog_parse(value)
          return if value.nil?
          return value if value.is_a? Data::UrlMapTests
          Data::UrlMapTestsCatalog.new(value)
        end

        # Used for parsing GCP API responses
        def self.api_parse(value)
          return if value.nil?
          return value if value.is_a? Data::UrlMapTests
          Data::UrlMapTestsApi.new(value)
        end
      end

      # A Chef property that holds an integer
      class UrlMapTestsArray < Google::Compute::Property::Array
        def self.coerce
          ->(x) { ::Google::Compute::Property::UrlMapTestsArray.catalog_parse(x) }
        end

        # Used for parsing Chef catalog
        def self.catalog_parse(value)
          return if value.nil?
          return UrlMapTests.catalog_parse(value) \
            unless value.is_a?(::Array)
          value.map { |v| UrlMapTests.catalog_parse(v) }
        end

        # Used for parsing GCP API responses
        def self.api_parse(value)
          return if value.nil?
          return UrlMapTests.api_parse(value) \
            unless value.is_a?(::Array)
          value.map { |v| UrlMapTests.api_parse(v) }
        end
      end
    end
  end
end
