# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'spec_helper'

# TODO(alexstephen): Reformat tests to use nested describe blocks
# TODO(alexstephen): Add title == name tests
# Test Matrix:
#
# +--------------------------------------------------------+
# | Action  | Exists | Changes | Success | Result          |
# +--------------------------------------------------------+
# | create  | Y      | Y       | Y       | Edit            |
# | create  | Y      | Y       | N       | Fail            |
# | create  | Y      | N       | Y       | Fetch (no-op)   |
# | create  | Y      | N       | N       | Fail            |
# | create  | N      | Y       | Y       | Create          |
# | create  | N      | Y       | N       | Fail            |
# +--------------------------------------------------------+
# | delete  | Y      | Y       | Y       | Delete          |
# | delete  | Y      | Y       | N       | Fail            |
# | delete  | N      | Y       | Y       | Fail (no delete)|
# | delete  | N      | Y       | N       | Fail            |
# +--------------------------------------------------------+
# TODO(alexstephen): Add tests for manage
# TODO(alexstephen): Add tests for modify
context 'gcompute_backend_service' do
  context 'ensure == present' do
    context 'resource exists' do
      # Ensure present: resource exists, no change
      context 'no changes == no action' do
        # Ensure present: resource exists, no change, no name
        context 'title == name' do
          # Ensure present: resource exists, no change, no name, pass
          context 'title == name (pass)' do
            before do
              allow(Time).to receive(:now).and_return(
                Time.new(2017, 1, 2, 3, 4, 5)
              )
              expect_network_get_success 1, name: 'title0'
              expect_network_get_success 2, name: 'title1'
              expect_network_get_success 3, name: 'title2'
              expect_network_get_success_zone 1
              expect_network_get_success_zone 2
              expect_network_get_success_zone 3
              expect_network_get_success_instance_group 1, zone: 'test name#0 data'
              expect_network_get_success_instance_group 2, zone: 'test name#1 data'
              expect_network_get_success_instance_group 3, zone: 'test name#2 data'
              expect_network_get_success_region 1
              expect_network_get_success_region 2
              expect_network_get_success_region 3
            end

            let(:runner) do
              # This path ensures that the current cookbook is
              # loaded for testing.
              # This path will load all other cookbooks in the
              # parent directory.
              # Under most circumstances, this will include the
              # real google-gauth cookbook.
              parent_dir = File.join(File.dirname(__FILE__), '..', '..')
              cookbook_paths = [parent_dir]

              # If there's no real version of the google-gauth ,
              # add in the mocked version so that the tests do not fail.
              # Since cookbooks can have any name, we assume that
              # any directory with the word auth is the google-gauth cookbook.
              cookbook_paths << File.join(File.dirname(__FILE__), 'cookbooks')

              ChefSpec::SoloRunner.new(
                step_into: %w[gcompute_backend_service gcompute_region gcompute_zone
                              gcompute_instance_group],
                cookbook_path: cookbook_paths,
                platform: 'ubuntu',
                version: '16.04'
              )
            end

            let(:chef_run) do
              apply_recipe(
                <<-MANIFEST
                  gcompute_zone 'resource(zone,0)' do
                    action :create
                    z_label 'test name#0 data'
                    project 'test project#0 data'
                    credential 'mycred'
                  end

                  gcompute_zone 'resource(zone,1)' do
                    action :create
                    z_label 'test name#1 data'
                    project 'test project#1 data'
                    credential 'mycred'
                  end

                  gcompute_zone 'resource(zone,2)' do
                    action :create
                    z_label 'test name#2 data'
                    project 'test project#2 data'
                    credential 'mycred'
                  end

                  gcompute_instance_group 'resource(instance_group,0)' do
                    action :create
                    ig_label 'test name#0 data'
                    zone 'resource(zone,0)'
                    project 'test project#0 data'
                    credential 'mycred'
                  end

                  gcompute_instance_group 'resource(instance_group,1)' do
                    action :create
                    ig_label 'test name#1 data'
                    zone 'resource(zone,1)'
                    project 'test project#1 data'
                    credential 'mycred'
                  end

                  gcompute_instance_group 'resource(instance_group,2)' do
                    action :create
                    ig_label 'test name#2 data'
                    zone 'resource(zone,2)'
                    project 'test project#2 data'
                    credential 'mycred'
                  end

                  gcompute_region 'resource(region,0)' do
                    action :create
                    r_label 'test name#0 data'
                    project 'test project#0 data'
                    credential 'mycred'
                  end

                  gcompute_region 'resource(region,1)' do
                    action :create
                    r_label 'test name#1 data'
                    project 'test project#1 data'
                    credential 'mycred'
                  end

                  gcompute_region 'resource(region,2)' do
                    action :create
                    r_label 'test name#2 data'
                    project 'test project#2 data'
                    credential 'mycred'
                  end

                  gcompute_backend_service 'title0' do
                    action :create
                    affinity_cookie_ttl_sec 1612732832
                    backends [
                      {
                        balancing_mode: 'UTILIZATION',
                        capacity_scaler: 26622430.32,
                        description: 'test description#0 data',
                        group: 'resource(instance_group,0)',
                        max_connections: 824204419,
                        max_connections_per_instance: 2749819302,
                        max_rate: 400354212,
                        max_rate_per_instance: 17253532.5,
                        max_utilization: 10960213.46
                      },
                      {
                        balancing_mode: 'RATE',
                        capacity_scaler: 53244860.65,
                        description: 'test description#1 data',
                        group: 'resource(instance_group,1)',
                        max_connections: 1648408839,
                        max_connections_per_instance: 5499638604,
                        max_rate: 800708425,
                        max_rate_per_instance: 34507065.0,
                        max_utilization: 21920426.93
                      },
                      {
                        balancing_mode: 'CONNECTION',
                        capacity_scaler: 79867290.98,
                        description: 'test description#2 data',
                        group: 'resource(instance_group,2)',
                        max_connections: 2472613258,
                        max_connections_per_instance: 8249457907,
                        max_rate: 1201062638,
                        max_rate_per_instance: 51760597.51,
                        max_utilization: 32880640.39
                      }
                    ]
                    cdn_policy({
                      cache_key_policy: {
                        include_host: true,
                        include_protocol: true,
                        include_query_string: true,
                        query_string_blacklist: ['pp', 'qq', 'rr', 'ss', 'tt'],
                        query_string_whitelist: ['dd', 'ee', 'ff', 'gg', 'hh']
                      }
                    })
                    connection_draining({
                      draining_timeout_sec: 2005106437
                    })
                    description 'test description#0 data'
                    enable_cdn true
                    health_checks ['rr', 'ss', 'tt', 'uu', 'vv']
                    iap({
                      enabled: true,
                      oauth2_client_id: 'test oauth2_client_id#0 data',
                      oauth2_client_secret: 'test oauth2_client_secret#0 data',
                      oauth2_client_secret_sha256: 'test oauth2_client_secret_sha256#0 data'
                    })
                    load_balancing_scheme 'INTERNAL'
                    port_name 'test port_name#0 data'
                    protocol 'HTTP'
                    region 'resource(region,0)'
                    session_affinity 'NONE'
                    timeout_sec 2704031721
                    project 'test project#0 data'
                    credential 'mycred'
                  end

                  gcompute_backend_service 'title1' do
                    action :create
                    affinity_cookie_ttl_sec 3225465664
                    backends [
                      {
                        balancing_mode: 'RATE',
                        capacity_scaler: 53244860.65,
                        description: 'test description#1 data',
                        group: 'resource(instance_group,1)',
                        max_connections: 1648408839,
                        max_connections_per_instance: 5499638604,
                        max_rate: 800708425,
                        max_rate_per_instance: 34507065.0,
                        max_utilization: 21920426.93
                      },
                      {
                        balancing_mode: 'CONNECTION',
                        capacity_scaler: 79867290.98,
                        description: 'test description#2 data',
                        group: 'resource(instance_group,2)',
                        max_connections: 2472613258,
                        max_connections_per_instance: 8249457907,
                        max_rate: 1201062638,
                        max_rate_per_instance: 51760597.51,
                        max_utilization: 32880640.39
                      },
                      {
                        balancing_mode: 'UTILIZATION',
                        capacity_scaler: 106489721.31,
                        description: 'test description#3 data',
                        group: 'resource(instance_group,0)',
                        max_connections: 3296817678,
                        max_connections_per_instance: 10999277209,
                        max_rate: 1601416850,
                        max_rate_per_instance: 69014130.1,
                        max_utilization: 43840853.86
                      }
                    ]
                    cdn_policy({
                      cache_key_policy: {
                        include_host: false,
                        include_protocol: false,
                        include_query_string: false,
                        query_string_blacklist: ['gg', 'hh', 'ii', 'jj'],
                        query_string_whitelist: ['jj', 'kk', 'll', 'mm', 'nn']
                      }
                    })
                    connection_draining({
                      draining_timeout_sec: 4010212875
                    })
                    description 'test description#1 data'
                    enable_cdn false
                    health_checks ['kk', 'll', 'mm', 'nn']
                    iap({
                      enabled: false,
                      oauth2_client_id: 'test oauth2_client_id#1 data',
                      oauth2_client_secret: 'test oauth2_client_secret#1 data',
                      oauth2_client_secret_sha256: 'test oauth2_client_secret_sha256#1 data'
                    })
                    load_balancing_scheme 'EXTERNAL'
                    port_name 'test port_name#1 data'
                    protocol 'HTTPS'
                    region 'resource(region,1)'
                    session_affinity 'CLIENT_IP'
                    timeout_sec 5408063442
                    project 'test project#1 data'
                    credential 'mycred'
                  end

                  gcompute_backend_service 'title2' do
                    action :create
                    affinity_cookie_ttl_sec 4838198497
                    backends [
                      {
                        balancing_mode: 'CONNECTION',
                        capacity_scaler: 79867290.98,
                        description: 'test description#2 data',
                        group: 'resource(instance_group,2)',
                        max_connections: 2472613258,
                        max_connections_per_instance: 8249457907,
                        max_rate: 1201062638,
                        max_rate_per_instance: 51760597.51,
                        max_utilization: 32880640.39
                      },
                      {
                        balancing_mode: 'UTILIZATION',
                        capacity_scaler: 106489721.31,
                        description: 'test description#3 data',
                        group: 'resource(instance_group,0)',
                        max_connections: 3296817678,
                        max_connections_per_instance: 10999277209,
                        max_rate: 1601416850,
                        max_rate_per_instance: 69014130.1,
                        max_utilization: 43840853.86
                      },
                      {
                        balancing_mode: 'RATE',
                        capacity_scaler: 133112151.64,
                        description: 'test description#4 data',
                        group: 'resource(instance_group,1)',
                        max_connections: 4121022097,
                        max_connections_per_instance: 13749096511,
                        max_rate: 2001771063,
                        max_rate_per_instance: 86267662.51,
                        max_utilization: 54801067.32
                      }
                    ]
                    cdn_policy({
                      cache_key_policy: {
                        include_host: true,
                        include_protocol: true,
                        include_query_string: true,
                        query_string_blacklist: ['xx', 'yy', 'zz'],
                        query_string_whitelist: ['oo', 'pp', 'qq', 'rr']
                      }
                    })
                    connection_draining({
                      draining_timeout_sec: 6015319313
                    })
                    description 'test description#2 data'
                    enable_cdn true
                    health_checks ['ee', 'ff', 'gg', 'hh']
                    iap({
                      enabled: true,
                      oauth2_client_id: 'test oauth2_client_id#2 data',
                      oauth2_client_secret: 'test oauth2_client_secret#2 data',
                      oauth2_client_secret_sha256: 'test oauth2_client_secret_sha256#2 data'
                    })
                    load_balancing_scheme 'INTERNAL'
                    port_name 'test port_name#2 data'
                    protocol 'TCP'
                    region 'resource(region,2)'
                    session_affinity 'GENERATED_COOKIE'
                    timeout_sec 8112095164
                    project 'test project#2 data'
                    credential 'mycred'
                  end
                MANIFEST
              ) do |recipe_name|
                runner.converge(recipe_name) do
                  cred = Google::CredentialResourceMock.new('mycred',
                                                            runner.run_context)
                  runner.resource_collection.insert(cred)
                end
              end
            end

            context 'gcompute_backend_service[title0]' do
              subject do
                chef_run.find_resource(:gcompute_backend_service, 'title0')
              end

              it { is_expected.to have_attributes(affinity_cookie_ttl_sec: 1_612_732_832) }

              # TODO(nelsonjr): Implement complex array object test.
              # it 'backends' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'cdnPolicy' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'connectionDraining' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(description: 'test description#0 data') }

              it { is_expected.to have_attributes(enable_cdn: true) }

              it { is_expected.to have_attributes(health_checks: %w[rr ss tt uu vv]) }

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'iap' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(load_balancing_scheme: 'INTERNAL') }

              it { is_expected.to have_attributes(bs_label: 'title0') }

              it { is_expected.to have_attributes(port_name: 'test port_name#0 data') }

              it { is_expected.to have_attributes(protocol: 'HTTP') }

              # TODO(alexstephen): Implement resourceref test.
              # it 'region' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(session_affinity: 'NONE') }

              it { is_expected.to have_attributes(timeout_sec: 2_704_031_721) }
            end

            context 'gcompute_backend_service[title1]' do
              subject do
                chef_run.find_resource(:gcompute_backend_service, 'title1')
              end

              it { is_expected.to have_attributes(affinity_cookie_ttl_sec: 3_225_465_664) }

              # TODO(nelsonjr): Implement complex array object test.
              # it 'backends' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'cdnPolicy' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'connectionDraining' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(description: 'test description#1 data') }

              it { is_expected.to have_attributes(enable_cdn: false) }

              it { is_expected.to have_attributes(health_checks: %w[kk ll mm nn]) }

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'iap' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(load_balancing_scheme: 'EXTERNAL') }

              it { is_expected.to have_attributes(bs_label: 'title1') }

              it { is_expected.to have_attributes(port_name: 'test port_name#1 data') }

              it { is_expected.to have_attributes(protocol: 'HTTPS') }

              # TODO(alexstephen): Implement resourceref test.
              # it 'region' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(session_affinity: 'CLIENT_IP') }

              it { is_expected.to have_attributes(timeout_sec: 5_408_063_442) }
            end

            context 'gcompute_backend_service[title2]' do
              subject do
                chef_run.find_resource(:gcompute_backend_service, 'title2')
              end

              it { is_expected.to have_attributes(affinity_cookie_ttl_sec: 4_838_198_497) }

              # TODO(nelsonjr): Implement complex array object test.
              # it 'backends' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'cdnPolicy' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'connectionDraining' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(description: 'test description#2 data') }

              it { is_expected.to have_attributes(enable_cdn: true) }

              it { is_expected.to have_attributes(health_checks: %w[ee ff gg hh]) }

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'iap' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(load_balancing_scheme: 'INTERNAL') }

              it { is_expected.to have_attributes(bs_label: 'title2') }

              it { is_expected.to have_attributes(port_name: 'test port_name#2 data') }

              it { is_expected.to have_attributes(protocol: 'TCP') }

              # TODO(alexstephen): Implement resourceref test.
              # it 'region' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(session_affinity: 'GENERATED_COOKIE') }

              it { is_expected.to have_attributes(timeout_sec: 8_112_095_164) }
            end
          end

          # Ensure present: resource exists, no change, no name, fail
          context 'title == name (fail)' do
            # TODO(alexstephen): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end

        # Ensure present: resource exists, no change, has name
        context 'title != name' do
          # Ensure present: resource exists, no change, has name, pass
          context 'title != name (pass)' do
            before do
              allow(Time).to receive(:now).and_return(
                Time.new(2017, 1, 2, 3, 4, 5)
              )
              expect_network_get_success 1
              expect_network_get_success 2
              expect_network_get_success 3
              expect_network_get_success_zone 1
              expect_network_get_success_zone 2
              expect_network_get_success_zone 3
              expect_network_get_success_instance_group 1, zone: 'test name#0 data'
              expect_network_get_success_instance_group 2, zone: 'test name#1 data'
              expect_network_get_success_instance_group 3, zone: 'test name#2 data'
              expect_network_get_success_region 1
              expect_network_get_success_region 2
              expect_network_get_success_region 3
            end

            let(:runner) do
              # This path ensures that the current cookbook is
              # loaded for testing.
              # This path will load all other cookbooks in the
              # parent directory.
              # Under most circumstances, this will include the
              # real google-gauth cookbook.
              parent_dir = File.join(File.dirname(__FILE__), '..', '..')
              cookbook_paths = [parent_dir]

              # If there's no real version of the google-gauth ,
              # add in the mocked version so that the tests do not fail.
              # Since cookbooks can have any name, we assume that
              # any directory with the word auth is the google-gauth cookbook.
              cookbook_paths << File.join(File.dirname(__FILE__), 'cookbooks')

              ChefSpec::SoloRunner.new(
                step_into: %w[gcompute_backend_service gcompute_region gcompute_zone
                              gcompute_instance_group],
                cookbook_path: cookbook_paths,
                platform: 'ubuntu',
                version: '16.04'
              )
            end

            let(:chef_run) do
              apply_recipe(
                <<-MANIFEST
                  gcompute_zone 'resource(zone,0)' do
                    action :create
                    z_label 'test name#0 data'
                    project 'test project#0 data'
                    credential 'mycred'
                  end

                  gcompute_zone 'resource(zone,1)' do
                    action :create
                    z_label 'test name#1 data'
                    project 'test project#1 data'
                    credential 'mycred'
                  end

                  gcompute_zone 'resource(zone,2)' do
                    action :create
                    z_label 'test name#2 data'
                    project 'test project#2 data'
                    credential 'mycred'
                  end

                  gcompute_instance_group 'resource(instance_group,0)' do
                    action :create
                    ig_label 'test name#0 data'
                    zone 'resource(zone,0)'
                    project 'test project#0 data'
                    credential 'mycred'
                  end

                  gcompute_instance_group 'resource(instance_group,1)' do
                    action :create
                    ig_label 'test name#1 data'
                    zone 'resource(zone,1)'
                    project 'test project#1 data'
                    credential 'mycred'
                  end

                  gcompute_instance_group 'resource(instance_group,2)' do
                    action :create
                    ig_label 'test name#2 data'
                    zone 'resource(zone,2)'
                    project 'test project#2 data'
                    credential 'mycred'
                  end

                  gcompute_region 'resource(region,0)' do
                    action :create
                    r_label 'test name#0 data'
                    project 'test project#0 data'
                    credential 'mycred'
                  end

                  gcompute_region 'resource(region,1)' do
                    action :create
                    r_label 'test name#1 data'
                    project 'test project#1 data'
                    credential 'mycred'
                  end

                  gcompute_region 'resource(region,2)' do
                    action :create
                    r_label 'test name#2 data'
                    project 'test project#2 data'
                    credential 'mycred'
                  end

                  gcompute_backend_service 'title0' do
                    action :create
                    affinity_cookie_ttl_sec 1612732832
                    backends [
                      {
                        balancing_mode: 'UTILIZATION',
                        capacity_scaler: 26622430.32,
                        description: 'test description#0 data',
                        group: 'resource(instance_group,0)',
                        max_connections: 824204419,
                        max_connections_per_instance: 2749819302,
                        max_rate: 400354212,
                        max_rate_per_instance: 17253532.5,
                        max_utilization: 10960213.46
                      },
                      {
                        balancing_mode: 'RATE',
                        capacity_scaler: 53244860.65,
                        description: 'test description#1 data',
                        group: 'resource(instance_group,1)',
                        max_connections: 1648408839,
                        max_connections_per_instance: 5499638604,
                        max_rate: 800708425,
                        max_rate_per_instance: 34507065.0,
                        max_utilization: 21920426.93
                      },
                      {
                        balancing_mode: 'CONNECTION',
                        capacity_scaler: 79867290.98,
                        description: 'test description#2 data',
                        group: 'resource(instance_group,2)',
                        max_connections: 2472613258,
                        max_connections_per_instance: 8249457907,
                        max_rate: 1201062638,
                        max_rate_per_instance: 51760597.51,
                        max_utilization: 32880640.39
                      }
                    ]
                    bs_label 'test name#0 data'
                    cdn_policy({
                      cache_key_policy: {
                        include_host: true,
                        include_protocol: true,
                        include_query_string: true,
                        query_string_blacklist: ['pp', 'qq', 'rr', 'ss', 'tt'],
                        query_string_whitelist: ['dd', 'ee', 'ff', 'gg', 'hh']
                      }
                    })
                    connection_draining({
                      draining_timeout_sec: 2005106437
                    })
                    description 'test description#0 data'
                    enable_cdn true
                    health_checks ['rr', 'ss', 'tt', 'uu', 'vv']
                    iap({
                      enabled: true,
                      oauth2_client_id: 'test oauth2_client_id#0 data',
                      oauth2_client_secret: 'test oauth2_client_secret#0 data',
                      oauth2_client_secret_sha256: 'test oauth2_client_secret_sha256#0 data'
                    })
                    load_balancing_scheme 'INTERNAL'
                    port_name 'test port_name#0 data'
                    protocol 'HTTP'
                    region 'resource(region,0)'
                    session_affinity 'NONE'
                    timeout_sec 2704031721
                    project 'test project#0 data'
                    credential 'mycred'
                  end

                  gcompute_backend_service 'title1' do
                    action :create
                    affinity_cookie_ttl_sec 3225465664
                    backends [
                      {
                        balancing_mode: 'RATE',
                        capacity_scaler: 53244860.65,
                        description: 'test description#1 data',
                        group: 'resource(instance_group,1)',
                        max_connections: 1648408839,
                        max_connections_per_instance: 5499638604,
                        max_rate: 800708425,
                        max_rate_per_instance: 34507065.0,
                        max_utilization: 21920426.93
                      },
                      {
                        balancing_mode: 'CONNECTION',
                        capacity_scaler: 79867290.98,
                        description: 'test description#2 data',
                        group: 'resource(instance_group,2)',
                        max_connections: 2472613258,
                        max_connections_per_instance: 8249457907,
                        max_rate: 1201062638,
                        max_rate_per_instance: 51760597.51,
                        max_utilization: 32880640.39
                      },
                      {
                        balancing_mode: 'UTILIZATION',
                        capacity_scaler: 106489721.31,
                        description: 'test description#3 data',
                        group: 'resource(instance_group,0)',
                        max_connections: 3296817678,
                        max_connections_per_instance: 10999277209,
                        max_rate: 1601416850,
                        max_rate_per_instance: 69014130.1,
                        max_utilization: 43840853.86
                      }
                    ]
                    bs_label 'test name#1 data'
                    cdn_policy({
                      cache_key_policy: {
                        include_host: false,
                        include_protocol: false,
                        include_query_string: false,
                        query_string_blacklist: ['gg', 'hh', 'ii', 'jj'],
                        query_string_whitelist: ['jj', 'kk', 'll', 'mm', 'nn']
                      }
                    })
                    connection_draining({
                      draining_timeout_sec: 4010212875
                    })
                    description 'test description#1 data'
                    enable_cdn false
                    health_checks ['kk', 'll', 'mm', 'nn']
                    iap({
                      enabled: false,
                      oauth2_client_id: 'test oauth2_client_id#1 data',
                      oauth2_client_secret: 'test oauth2_client_secret#1 data',
                      oauth2_client_secret_sha256: 'test oauth2_client_secret_sha256#1 data'
                    })
                    load_balancing_scheme 'EXTERNAL'
                    port_name 'test port_name#1 data'
                    protocol 'HTTPS'
                    region 'resource(region,1)'
                    session_affinity 'CLIENT_IP'
                    timeout_sec 5408063442
                    project 'test project#1 data'
                    credential 'mycred'
                  end

                  gcompute_backend_service 'title2' do
                    action :create
                    affinity_cookie_ttl_sec 4838198497
                    backends [
                      {
                        balancing_mode: 'CONNECTION',
                        capacity_scaler: 79867290.98,
                        description: 'test description#2 data',
                        group: 'resource(instance_group,2)',
                        max_connections: 2472613258,
                        max_connections_per_instance: 8249457907,
                        max_rate: 1201062638,
                        max_rate_per_instance: 51760597.51,
                        max_utilization: 32880640.39
                      },
                      {
                        balancing_mode: 'UTILIZATION',
                        capacity_scaler: 106489721.31,
                        description: 'test description#3 data',
                        group: 'resource(instance_group,0)',
                        max_connections: 3296817678,
                        max_connections_per_instance: 10999277209,
                        max_rate: 1601416850,
                        max_rate_per_instance: 69014130.1,
                        max_utilization: 43840853.86
                      },
                      {
                        balancing_mode: 'RATE',
                        capacity_scaler: 133112151.64,
                        description: 'test description#4 data',
                        group: 'resource(instance_group,1)',
                        max_connections: 4121022097,
                        max_connections_per_instance: 13749096511,
                        max_rate: 2001771063,
                        max_rate_per_instance: 86267662.51,
                        max_utilization: 54801067.32
                      }
                    ]
                    bs_label 'test name#2 data'
                    cdn_policy({
                      cache_key_policy: {
                        include_host: true,
                        include_protocol: true,
                        include_query_string: true,
                        query_string_blacklist: ['xx', 'yy', 'zz'],
                        query_string_whitelist: ['oo', 'pp', 'qq', 'rr']
                      }
                    })
                    connection_draining({
                      draining_timeout_sec: 6015319313
                    })
                    description 'test description#2 data'
                    enable_cdn true
                    health_checks ['ee', 'ff', 'gg', 'hh']
                    iap({
                      enabled: true,
                      oauth2_client_id: 'test oauth2_client_id#2 data',
                      oauth2_client_secret: 'test oauth2_client_secret#2 data',
                      oauth2_client_secret_sha256: 'test oauth2_client_secret_sha256#2 data'
                    })
                    load_balancing_scheme 'INTERNAL'
                    port_name 'test port_name#2 data'
                    protocol 'TCP'
                    region 'resource(region,2)'
                    session_affinity 'GENERATED_COOKIE'
                    timeout_sec 8112095164
                    project 'test project#2 data'
                    credential 'mycred'
                  end
                MANIFEST
              ) do |recipe_name|
                runner.converge(recipe_name) do
                  cred = Google::CredentialResourceMock.new('mycred',
                                                            runner.run_context)
                  runner.resource_collection.insert(cred)
                end
              end
            end

            context 'gcompute_backend_service[title0]' do
              subject do
                chef_run.find_resource(:gcompute_backend_service, 'title0')
              end

              it { is_expected.to have_attributes(affinity_cookie_ttl_sec: 1_612_732_832) }

              # TODO(nelsonjr): Implement complex array object test.
              # it 'backends' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'cdnPolicy' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'connectionDraining' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(description: 'test description#0 data') }

              it { is_expected.to have_attributes(enable_cdn: true) }

              it { is_expected.to have_attributes(health_checks: %w[rr ss tt uu vv]) }

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'iap' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(load_balancing_scheme: 'INTERNAL') }

              it { is_expected.to have_attributes(bs_label: 'test name#0 data') }

              it { is_expected.to have_attributes(port_name: 'test port_name#0 data') }

              it { is_expected.to have_attributes(protocol: 'HTTP') }

              # TODO(alexstephen): Implement resourceref test.
              # it 'region' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(session_affinity: 'NONE') }

              it { is_expected.to have_attributes(timeout_sec: 2_704_031_721) }
            end

            context 'gcompute_backend_service[title1]' do
              subject do
                chef_run.find_resource(:gcompute_backend_service, 'title1')
              end

              it { is_expected.to have_attributes(affinity_cookie_ttl_sec: 3_225_465_664) }

              # TODO(nelsonjr): Implement complex array object test.
              # it 'backends' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'cdnPolicy' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'connectionDraining' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(description: 'test description#1 data') }

              it { is_expected.to have_attributes(enable_cdn: false) }

              it { is_expected.to have_attributes(health_checks: %w[kk ll mm nn]) }

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'iap' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(load_balancing_scheme: 'EXTERNAL') }

              it { is_expected.to have_attributes(bs_label: 'test name#1 data') }

              it { is_expected.to have_attributes(port_name: 'test port_name#1 data') }

              it { is_expected.to have_attributes(protocol: 'HTTPS') }

              # TODO(alexstephen): Implement resourceref test.
              # it 'region' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(session_affinity: 'CLIENT_IP') }

              it { is_expected.to have_attributes(timeout_sec: 5_408_063_442) }
            end

            context 'gcompute_backend_service[title2]' do
              subject do
                chef_run.find_resource(:gcompute_backend_service, 'title2')
              end

              it { is_expected.to have_attributes(affinity_cookie_ttl_sec: 4_838_198_497) }

              # TODO(nelsonjr): Implement complex array object test.
              # it 'backends' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'cdnPolicy' do
              #   # Add test code here
              # end

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'connectionDraining' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(description: 'test description#2 data') }

              it { is_expected.to have_attributes(enable_cdn: true) }

              it { is_expected.to have_attributes(health_checks: %w[ee ff gg hh]) }

              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'iap' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(load_balancing_scheme: 'INTERNAL') }

              it { is_expected.to have_attributes(bs_label: 'test name#2 data') }

              it { is_expected.to have_attributes(port_name: 'test port_name#2 data') }

              it { is_expected.to have_attributes(protocol: 'TCP') }

              # TODO(alexstephen): Implement resourceref test.
              # it 'region' do
              #   # Add test code here
              # end

              it { is_expected.to have_attributes(session_affinity: 'GENERATED_COOKIE') }

              it { is_expected.to have_attributes(timeout_sec: 8_112_095_164) }
            end
          end

          # Ensure present: resource exists, no change, has name, fail
          context 'title != name (fail)' do
            # TODO(alexstephen): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end
      end

      # Ensure present: resource exists, changes
      context 'changes == action' do
        # Ensure present: resource exists, changes, no name
        context 'title == name' do
          # Ensure present: resource exists, changes, no name, pass
          context 'title == name (pass)' do
            # TODO(alexstephen): Implement new test format.
          end

          # Ensure present: resource exists, changes, no name, fail
          context 'title == name (fail)' do
            # TODO(alexstephen): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end

        # Ensure present: resource exists, changes, has name
        context 'title != name' do
          # Ensure present: resource exists, changes, has name, pass
          context 'title != name (pass)' do
            # TODO(alexstephen): Implement new test format
          end

          # Ensure present: resource exists, changes, has name, fail
          context 'title != name (fail)' do
            # TODO(alexstephen): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end
      end
    end

    context 'resource missing' do
      # Ensure present: resource missing, ignore, no name
      context 'title == name' do
        # Ensure present: resource missing, ignore, no name, pass
        context 'title == name (pass)' do
          before do
            expect_network_get_failed 1, name: 'title0'
            expect_network_create \
              1,
              {
                'kind' => 'compute#backendService',
                'affinityCookieTtlSec' => 1_612_732_832,
                'backends' => [
                  {
                    'balancingMode' => 'UTILIZATION',
                    'capacityScaler' => 26_622_430.32,
                    'description' => 'test description#0 data',
                    'group' => 'selflink(resource(instance_group,0))',
                    'maxConnections' => 824_204_419,
                    'maxConnectionsPerInstance' => 2_749_819_302,
                    'maxRate' => 400_354_212,
                    'maxRatePerInstance' => 17_253_532.5,
                    'maxUtilization' => 10_960_213.46
                  },
                  {
                    'balancingMode' => 'RATE',
                    'capacityScaler' => 53_244_860.65,
                    'description' => 'test description#1 data',
                    'group' => 'selflink(resource(instance_group,1))',
                    'maxConnections' => 1_648_408_839,
                    'maxConnectionsPerInstance' => 5_499_638_604,
                    'maxRate' => 800_708_425,
                    'maxRatePerInstance' => 34_507_065.0,
                    'maxUtilization' => 21_920_426.93
                  },
                  {
                    'balancingMode' => 'CONNECTION',
                    'capacityScaler' => 79_867_290.98,
                    'description' => 'test description#2 data',
                    'group' => 'selflink(resource(instance_group,2))',
                    'maxConnections' => 2_472_613_258,
                    'maxConnectionsPerInstance' => 8_249_457_907,
                    'maxRate' => 1_201_062_638,
                    'maxRatePerInstance' => 51_760_597.51,
                    'maxUtilization' => 32_880_640.39
                  }
                ],
                'cdnPolicy' => {
                  'cacheKeyPolicy' => {
                    'includeHost' => true,
                    'includeProtocol' => true,
                    'includeQueryString' => true,
                    'queryStringBlacklist' => %w[pp qq rr ss tt],
                    'queryStringWhitelist' => %w[dd ee ff gg hh]
                  }
                },
                'connectionDraining' => {
                  'drainingTimeoutSec' => 2_005_106_437
                },
                'description' => 'test description#0 data',
                'enableCDN' => true,
                'healthChecks' => %w[rr ss tt uu vv],
                'iap' => {
                  'enabled' => true,
                  'oauth2ClientId' => 'test oauth2_client_id#0 data',
                  'oauth2ClientSecret' => 'test oauth2_client_secret#0 data',
                  'oauth2ClientSecretSha256' => 'test oauth2_client_secret_sha256#0 data'
                },
                'loadBalancingScheme' => 'INTERNAL',
                'name' => 'title0',
                'portName' => 'test port_name#0 data',
                'protocol' => 'HTTP',
                'region' => 'selflink(resource(region,0))',
                'sessionAffinity' => 'NONE',
                'timeoutSec' => 2_704_031_721
              },
              name: 'title0'
            expect_network_get_async 1, name: 'title0'
            expect_network_get_success_zone 1
            expect_network_get_success_zone 2
            expect_network_get_success_zone 3
            expect_network_get_success_instance_group 1, zone: 'test name#0 data'
            expect_network_get_success_instance_group 2, zone: 'test name#1 data'
            expect_network_get_success_instance_group 3, zone: 'test name#2 data'
            expect_network_get_success_region 1
          end

          let(:runner) do
            # This path ensures that the current cookbook is
            # loaded for testing.
            # This path will load all other cookbooks in the
            # parent directory.
            # Under most circumstances, this will include the
            # real google-gauth cookbook.
            parent_dir = File.join(File.dirname(__FILE__), '..', '..')
            cookbook_paths = [parent_dir]

            # If there's no real version of the google-gauth ,
            # add in the mocked version so that the tests do not fail.
            # Since cookbooks can have any name, we assume that
            # any directory with the word auth is the google-gauth cookbook.
            cookbook_paths << File.join(File.dirname(__FILE__), 'cookbooks')

            ChefSpec::SoloRunner.new(
              step_into: %w[gcompute_backend_service gcompute_region gcompute_zone
                            gcompute_instance_group],
              cookbook_path: cookbook_paths,
              platform: 'ubuntu',
              version: '16.04'
            )
          end

          let(:chef_run) do
            apply_recipe(
              <<-MANIFEST
                gcompute_zone 'resource(zone,0)' do
                  action :create
                  z_label 'test name#0 data'
                  project 'test project#0 data'
                  credential 'mycred'
                end

                gcompute_zone 'resource(zone,1)' do
                  action :create
                  z_label 'test name#1 data'
                  project 'test project#1 data'
                  credential 'mycred'
                end

                gcompute_zone 'resource(zone,2)' do
                  action :create
                  z_label 'test name#2 data'
                  project 'test project#2 data'
                  credential 'mycred'
                end

                gcompute_instance_group 'resource(instance_group,0)' do
                  action :create
                  ig_label 'test name#0 data'
                  zone 'resource(zone,0)'
                  project 'test project#0 data'
                  credential 'mycred'
                end

                gcompute_instance_group 'resource(instance_group,1)' do
                  action :create
                  ig_label 'test name#1 data'
                  zone 'resource(zone,1)'
                  project 'test project#1 data'
                  credential 'mycred'
                end

                gcompute_instance_group 'resource(instance_group,2)' do
                  action :create
                  ig_label 'test name#2 data'
                  zone 'resource(zone,2)'
                  project 'test project#2 data'
                  credential 'mycred'
                end

                gcompute_region 'resource(region,0)' do
                  action :create
                  r_label 'test name#0 data'
                  project 'test project#0 data'
                  credential 'mycred'
                end

                gcompute_backend_service 'title0' do
                  action :create
                  affinity_cookie_ttl_sec 1612732832
                  backends [
                    {
                      balancing_mode: 'UTILIZATION',
                      capacity_scaler: 26622430.32,
                      description: 'test description#0 data',
                      group: 'resource(instance_group,0)',
                      max_connections: 824204419,
                      max_connections_per_instance: 2749819302,
                      max_rate: 400354212,
                      max_rate_per_instance: 17253532.5,
                      max_utilization: 10960213.46
                    },
                    {
                      balancing_mode: 'RATE',
                      capacity_scaler: 53244860.65,
                      description: 'test description#1 data',
                      group: 'resource(instance_group,1)',
                      max_connections: 1648408839,
                      max_connections_per_instance: 5499638604,
                      max_rate: 800708425,
                      max_rate_per_instance: 34507065.0,
                      max_utilization: 21920426.93
                    },
                    {
                      balancing_mode: 'CONNECTION',
                      capacity_scaler: 79867290.98,
                      description: 'test description#2 data',
                      group: 'resource(instance_group,2)',
                      max_connections: 2472613258,
                      max_connections_per_instance: 8249457907,
                      max_rate: 1201062638,
                      max_rate_per_instance: 51760597.51,
                      max_utilization: 32880640.39
                    }
                  ]
                  cdn_policy({
                    cache_key_policy: {
                      include_host: true,
                      include_protocol: true,
                      include_query_string: true,
                      query_string_blacklist: ['pp', 'qq', 'rr', 'ss', 'tt'],
                      query_string_whitelist: ['dd', 'ee', 'ff', 'gg', 'hh']
                    }
                  })
                  connection_draining({
                    draining_timeout_sec: 2005106437
                  })
                  description 'test description#0 data'
                  enable_cdn true
                  health_checks ['rr', 'ss', 'tt', 'uu', 'vv']
                  iap({
                    enabled: true,
                    oauth2_client_id: 'test oauth2_client_id#0 data',
                    oauth2_client_secret: 'test oauth2_client_secret#0 data',
                    oauth2_client_secret_sha256: 'test oauth2_client_secret_sha256#0 data'
                  })
                  load_balancing_scheme 'INTERNAL'
                  port_name 'test port_name#0 data'
                  protocol 'HTTP'
                  region 'resource(region,0)'
                  session_affinity 'NONE'
                  timeout_sec 2704031721
                  project 'test project#0 data'
                  credential 'mycred'
                end
              MANIFEST
            ) do |recipe_name|
              runner.converge(recipe_name) do
                cred = Google::CredentialResourceMock.new('mycred',
                                                          runner.run_context)
                runner.resource_collection.insert(cred)
              end
            end
          end

          subject do
            chef_run.find_resource(:gcompute_backend_service, 'title0')
          end

          it 'should run test correctly' do
            expect(chef_run).to create(:gcompute_backend_service,
                                       'title0')
          end
          it { is_expected.to have_attributes(affinity_cookie_ttl_sec: 1_612_732_832) }

          # TODO(nelsonjr): Implement complex array object test.
          # it 'backends' do
          #   # Add test code here
          # end

          # TODO(nelsonjr): Implement complex nested property object test.
          # it 'cdnPolicy' do
          #   # Add test code here
          # end

          # TODO(nelsonjr): Implement complex nested property object test.
          # it 'connectionDraining' do
          #   # Add test code here
          # end

          it { is_expected.to have_attributes(description: 'test description#0 data') }

          it { is_expected.to have_attributes(enable_cdn: true) }

          it { is_expected.to have_attributes(health_checks: %w[rr ss tt uu vv]) }

          # TODO(nelsonjr): Implement complex nested property object test.
          # it 'iap' do
          #   # Add test code here
          # end

          it { is_expected.to have_attributes(load_balancing_scheme: 'INTERNAL') }

          it { is_expected.to have_attributes(bs_label: 'title0') }

          it { is_expected.to have_attributes(port_name: 'test port_name#0 data') }

          it { is_expected.to have_attributes(protocol: 'HTTP') }

          # TODO(alexstephen): Implement resourceref test.
          # it 'region' do
          #   # Add test code here
          # end

          it { is_expected.to have_attributes(session_affinity: 'NONE') }

          it { is_expected.to have_attributes(timeout_sec: 2_704_031_721) }
        end

        # Ensure present: resource missing, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(alexstephen): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end

      # Ensure present: resource missing, ignore, has name
      context 'title != name' do
        # Ensure present: resource missing, ignore, has name, pass
        context 'title != name (pass)' do
          before do
            expect_network_get_failed 1
            expect_network_create \
              1,
              'kind' => 'compute#backendService',
              'affinityCookieTtlSec' => 1_612_732_832,
              'backends' => [
                {
                  'balancingMode' => 'UTILIZATION',
                  'capacityScaler' => 26_622_430.32,
                  'description' => 'test description#0 data',
                  'group' => 'selflink(resource(instance_group,0))',
                  'maxConnections' => 824_204_419,
                  'maxConnectionsPerInstance' => 2_749_819_302,
                  'maxRate' => 400_354_212,
                  'maxRatePerInstance' => 17_253_532.5,
                  'maxUtilization' => 10_960_213.46
                },
                {
                  'balancingMode' => 'RATE',
                  'capacityScaler' => 53_244_860.65,
                  'description' => 'test description#1 data',
                  'group' => 'selflink(resource(instance_group,1))',
                  'maxConnections' => 1_648_408_839,
                  'maxConnectionsPerInstance' => 5_499_638_604,
                  'maxRate' => 800_708_425,
                  'maxRatePerInstance' => 34_507_065.0,
                  'maxUtilization' => 21_920_426.93
                },
                {
                  'balancingMode' => 'CONNECTION',
                  'capacityScaler' => 79_867_290.98,
                  'description' => 'test description#2 data',
                  'group' => 'selflink(resource(instance_group,2))',
                  'maxConnections' => 2_472_613_258,
                  'maxConnectionsPerInstance' => 8_249_457_907,
                  'maxRate' => 1_201_062_638,
                  'maxRatePerInstance' => 51_760_597.51,
                  'maxUtilization' => 32_880_640.39
                }
              ],
              'cdnPolicy' => {
                'cacheKeyPolicy' => {
                  'includeHost' => true,
                  'includeProtocol' => true,
                  'includeQueryString' => true,
                  'queryStringBlacklist' => %w[pp qq rr ss tt],
                  'queryStringWhitelist' => %w[dd ee ff gg hh]
                }
              },
              'connectionDraining' => {
                'drainingTimeoutSec' => 2_005_106_437
              },
              'description' => 'test description#0 data',
              'enableCDN' => true,
              'healthChecks' => %w[rr ss tt uu vv],
              'iap' => {
                'enabled' => true,
                'oauth2ClientId' => 'test oauth2_client_id#0 data',
                'oauth2ClientSecret' => 'test oauth2_client_secret#0 data',
                'oauth2ClientSecretSha256' => 'test oauth2_client_secret_sha256#0 data'
              },
              'loadBalancingScheme' => 'INTERNAL',
              'name' => 'test name#0 data',
              'portName' => 'test port_name#0 data',
              'protocol' => 'HTTP',
              'region' => 'selflink(resource(region,0))',
              'sessionAffinity' => 'NONE',
              'timeoutSec' => 2_704_031_721
            expect_network_get_async 1
            expect_network_get_success_zone 1
            expect_network_get_success_zone 2
            expect_network_get_success_zone 3
            expect_network_get_success_instance_group 1, zone: 'test name#0 data'
            expect_network_get_success_instance_group 2, zone: 'test name#1 data'
            expect_network_get_success_instance_group 3, zone: 'test name#2 data'
            expect_network_get_success_region 1
          end

          let(:runner) do
            # This path ensures that the current cookbook is
            # loaded for testing.
            # This path will load all other cookbooks in the
            # parent directory.
            # Under most circumstances, this will include the
            # real google-gauth cookbook.
            parent_dir = File.join(File.dirname(__FILE__), '..', '..')
            cookbook_paths = [parent_dir]

            # If there's no real version of the google-gauth ,
            # add in the mocked version so that the tests do not fail.
            # Since cookbooks can have any name, we assume that
            # any directory with the word auth is the google-gauth cookbook.
            cookbook_paths << File.join(File.dirname(__FILE__), 'cookbooks')

            ChefSpec::SoloRunner.new(
              step_into: %w[gcompute_backend_service gcompute_region gcompute_zone
                            gcompute_instance_group],
              cookbook_path: cookbook_paths,
              platform: 'ubuntu',
              version: '16.04'
            )
          end

          let(:chef_run) do
            apply_recipe(
              <<-MANIFEST
                gcompute_zone 'resource(zone,0)' do
                  action :create
                  z_label 'test name#0 data'
                  project 'test project#0 data'
                  credential 'mycred'
                end

                gcompute_zone 'resource(zone,1)' do
                  action :create
                  z_label 'test name#1 data'
                  project 'test project#1 data'
                  credential 'mycred'
                end

                gcompute_zone 'resource(zone,2)' do
                  action :create
                  z_label 'test name#2 data'
                  project 'test project#2 data'
                  credential 'mycred'
                end

                gcompute_instance_group 'resource(instance_group,0)' do
                  action :create
                  ig_label 'test name#0 data'
                  zone 'resource(zone,0)'
                  project 'test project#0 data'
                  credential 'mycred'
                end

                gcompute_instance_group 'resource(instance_group,1)' do
                  action :create
                  ig_label 'test name#1 data'
                  zone 'resource(zone,1)'
                  project 'test project#1 data'
                  credential 'mycred'
                end

                gcompute_instance_group 'resource(instance_group,2)' do
                  action :create
                  ig_label 'test name#2 data'
                  zone 'resource(zone,2)'
                  project 'test project#2 data'
                  credential 'mycred'
                end

                gcompute_region 'resource(region,0)' do
                  action :create
                  r_label 'test name#0 data'
                  project 'test project#0 data'
                  credential 'mycred'
                end

                gcompute_backend_service 'title0' do
                  action :create
                  affinity_cookie_ttl_sec 1612732832
                  backends [
                    {
                      balancing_mode: 'UTILIZATION',
                      capacity_scaler: 26622430.32,
                      description: 'test description#0 data',
                      group: 'resource(instance_group,0)',
                      max_connections: 824204419,
                      max_connections_per_instance: 2749819302,
                      max_rate: 400354212,
                      max_rate_per_instance: 17253532.5,
                      max_utilization: 10960213.46
                    },
                    {
                      balancing_mode: 'RATE',
                      capacity_scaler: 53244860.65,
                      description: 'test description#1 data',
                      group: 'resource(instance_group,1)',
                      max_connections: 1648408839,
                      max_connections_per_instance: 5499638604,
                      max_rate: 800708425,
                      max_rate_per_instance: 34507065.0,
                      max_utilization: 21920426.93
                    },
                    {
                      balancing_mode: 'CONNECTION',
                      capacity_scaler: 79867290.98,
                      description: 'test description#2 data',
                      group: 'resource(instance_group,2)',
                      max_connections: 2472613258,
                      max_connections_per_instance: 8249457907,
                      max_rate: 1201062638,
                      max_rate_per_instance: 51760597.51,
                      max_utilization: 32880640.39
                    }
                  ]
                  bs_label 'test name#0 data'
                  cdn_policy({
                    cache_key_policy: {
                      include_host: true,
                      include_protocol: true,
                      include_query_string: true,
                      query_string_blacklist: ['pp', 'qq', 'rr', 'ss', 'tt'],
                      query_string_whitelist: ['dd', 'ee', 'ff', 'gg', 'hh']
                    }
                  })
                  connection_draining({
                    draining_timeout_sec: 2005106437
                  })
                  description 'test description#0 data'
                  enable_cdn true
                  health_checks ['rr', 'ss', 'tt', 'uu', 'vv']
                  iap({
                    enabled: true,
                    oauth2_client_id: 'test oauth2_client_id#0 data',
                    oauth2_client_secret: 'test oauth2_client_secret#0 data',
                    oauth2_client_secret_sha256: 'test oauth2_client_secret_sha256#0 data'
                  })
                  load_balancing_scheme 'INTERNAL'
                  port_name 'test port_name#0 data'
                  protocol 'HTTP'
                  region 'resource(region,0)'
                  session_affinity 'NONE'
                  timeout_sec 2704031721
                  project 'test project#0 data'
                  credential 'mycred'
                end
              MANIFEST
            ) do |recipe_name|
              runner.converge(recipe_name) do
                cred = Google::CredentialResourceMock.new('mycred',
                                                          runner.run_context)
                runner.resource_collection.insert(cred)
              end
            end
          end

          subject do
            chef_run.find_resource(:gcompute_backend_service, 'title0')
          end

          it 'should run test correctly' do
            expect(chef_run).to create(:gcompute_backend_service,
                                       'title0')
          end
          it { is_expected.to have_attributes(affinity_cookie_ttl_sec: 1_612_732_832) }

          # TODO(nelsonjr): Implement complex array object test.
          # it 'backends' do
          #   # Add test code here
          # end

          # TODO(nelsonjr): Implement complex nested property object test.
          # it 'cdnPolicy' do
          #   # Add test code here
          # end

          # TODO(nelsonjr): Implement complex nested property object test.
          # it 'connectionDraining' do
          #   # Add test code here
          # end

          it { is_expected.to have_attributes(description: 'test description#0 data') }

          it { is_expected.to have_attributes(enable_cdn: true) }

          it { is_expected.to have_attributes(health_checks: %w[rr ss tt uu vv]) }

          # TODO(nelsonjr): Implement complex nested property object test.
          # it 'iap' do
          #   # Add test code here
          # end

          it { is_expected.to have_attributes(load_balancing_scheme: 'INTERNAL') }

          it { is_expected.to have_attributes(bs_label: 'test name#0 data') }

          it { is_expected.to have_attributes(port_name: 'test port_name#0 data') }

          it { is_expected.to have_attributes(protocol: 'HTTP') }

          # TODO(alexstephen): Implement resourceref test.
          # it 'region' do
          #   # Add test code here
          # end

          it { is_expected.to have_attributes(session_affinity: 'NONE') }

          it { is_expected.to have_attributes(timeout_sec: 2_704_031_721) }
        end

        # Ensure present: resource missing, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(alexstephen): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end
  end

  context 'ensure == absent' do
    context 'resource missing' do
      # Ensure absent: resource missing, ignore, no name
      context 'title == name' do
        # Ensure absent: resource missing, ignore, no name, pass
        context 'title == name (pass)' do
          before do
            expect_network_get_failed 1, name: 'title0'
          end

          let(:runner) do
            # This path ensures that the current cookbook is
            # loaded for testing.
            # This path will load all other cookbooks in the
            # parent directory.
            # Under most circumstances, this will include the
            # real google-gauth cookbook.
            parent_dir = File.join(File.dirname(__FILE__), '..', '..')
            cookbook_paths = [parent_dir]

            # If there's no real version of the google-gauth ,
            # add in the mocked version so that the tests do not fail.
            # Since cookbooks can have any name, we assume that
            # any directory with the word auth is the google-gauth cookbook.
            cookbook_paths << File.join(File.dirname(__FILE__), 'cookbooks')

            ChefSpec::SoloRunner.new(
              step_into: %w[gcompute_backend_service gcompute_region gcompute_zone
                            gcompute_instance_group],
              cookbook_path: cookbook_paths,
              platform: 'ubuntu',
              version: '16.04'
            )
          end

          let(:chef_run) do
            apply_recipe(
              <<-MANIFEST
                gcompute_backend_service 'title0' do
                  action :delete
                  project 'test project#0 data'
                  credential 'mycred'
                end
              MANIFEST
            ) do |recipe_name|
              runner.converge(recipe_name) do
                cred = Google::CredentialResourceMock.new('mycred',
                                                          runner.run_context)
                runner.resource_collection.insert(cred)
              end
            end
          end

          subject do
            chef_run.find_resource(:gcompute_backend_service, 'title0')
          end
        end

        # Ensure absent: resource missing, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(alexstephen): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end

      # Ensure absent: resource missing, ignore, has name
      context 'title != name' do
        # Ensure absent: resource missing, ignore, has name, pass
        context 'title != name (pass)' do
          before do
            expect_network_get_failed 1
          end

          let(:runner) do
            # This path ensures that the current cookbook is
            # loaded for testing.
            # This path will load all other cookbooks in the
            # parent directory.
            # Under most circumstances, this will include the
            # real google-gauth cookbook.
            parent_dir = File.join(File.dirname(__FILE__), '..', '..')
            cookbook_paths = [parent_dir]

            # If there's no real version of the google-gauth ,
            # add in the mocked version so that the tests do not fail.
            # Since cookbooks can have any name, we assume that
            # any directory with the word auth is the google-gauth cookbook.
            cookbook_paths << File.join(File.dirname(__FILE__), 'cookbooks')

            ChefSpec::SoloRunner.new(
              step_into: %w[gcompute_backend_service gcompute_region gcompute_zone
                            gcompute_instance_group],
              cookbook_path: cookbook_paths,
              platform: 'ubuntu',
              version: '16.04'
            )
          end

          let(:chef_run) do
            apply_recipe(
              <<-MANIFEST
                gcompute_backend_service 'title0' do
                  action :delete
                  bs_label 'test name#0 data'
                  project 'test project#0 data'
                  credential 'mycred'
                end
              MANIFEST
            ) do |recipe_name|
              runner.converge(recipe_name) do
                cred = Google::CredentialResourceMock.new('mycred',
                                                          runner.run_context)
                runner.resource_collection.insert(cred)
              end
            end
          end

          subject do
            chef_run.find_resource(:gcompute_backend_service, 'title0')
          end
        end

        # Ensure absent: resource missing, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(alexstephen): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end

    context 'resource exists' do
      # Ensure absent: resource exists, ignore, no name
      context 'title == name' do
        # Ensure absent: resource exists, ignore, no name, pass
        context 'title == name (pass)' do
          before do
            expect_network_get_success 1, name: 'title0'
            expect_network_delete 1, 'title0'
            expect_network_get_async 1, name: 'title0'
          end

          let(:runner) do
            # This path ensures that the current cookbook is
            # loaded for testing.
            # This path will load all other cookbooks in the
            # parent directory.
            # Under most circumstances, this will include the
            # real google-gauth cookbook.
            parent_dir = File.join(File.dirname(__FILE__), '..', '..')
            cookbook_paths = [parent_dir]

            # If there's no real version of the google-gauth ,
            # add in the mocked version so that the tests do not fail.
            # Since cookbooks can have any name, we assume that
            # any directory with the word auth is the google-gauth cookbook.
            cookbook_paths << File.join(File.dirname(__FILE__), 'cookbooks')

            ChefSpec::SoloRunner.new(
              step_into: %w[gcompute_backend_service gcompute_region gcompute_zone
                            gcompute_instance_group],
              cookbook_path: cookbook_paths,
              platform: 'ubuntu',
              version: '16.04'
            )
          end

          let(:chef_run) do
            apply_recipe(
              <<-MANIFEST
                gcompute_backend_service 'title0' do
                  action :delete
                  project 'test project#0 data'
                  credential 'mycred'
                end
              MANIFEST
            ) do |recipe_name|
              runner.converge(recipe_name) do
                cred = Google::CredentialResourceMock.new('mycred',
                                                          runner.run_context)
                runner.resource_collection.insert(cred)
              end
            end
          end

          subject do
            chef_run.find_resource(:gcompute_backend_service, 'title0')
          end

          it 'should run test correctly' do
            expect(chef_run).to delete(:gcompute_backend_service,
                                       'title0')
          end
        end

        # Ensure absent: resource exists, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(alexstephen): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
      # Ensure absent: resource exists, ignore, has name
      context 'title != name' do
        # Ensure absent: resource exists, ignore, has name, pass
        context 'title != name (pass)' do
          before do
            expect_network_get_success 1
            expect_network_delete 1
            expect_network_get_async 1
          end

          let(:runner) do
            # This path ensures that the current cookbook is
            # loaded for testing.
            # This path will load all other cookbooks in the
            # parent directory.
            # Under most circumstances, this will include the
            # real google-gauth cookbook.
            parent_dir = File.join(File.dirname(__FILE__), '..', '..')
            cookbook_paths = [parent_dir]

            # If there's no real version of the google-gauth ,
            # add in the mocked version so that the tests do not fail.
            # Since cookbooks can have any name, we assume that
            # any directory with the word auth is the google-gauth cookbook.
            cookbook_paths << File.join(File.dirname(__FILE__), 'cookbooks')

            ChefSpec::SoloRunner.new(
              step_into: %w[gcompute_backend_service gcompute_region gcompute_zone
                            gcompute_instance_group],
              cookbook_path: cookbook_paths,
              platform: 'ubuntu',
              version: '16.04'
            )
          end

          let(:chef_run) do
            apply_recipe(
              <<-MANIFEST
                gcompute_backend_service 'title0' do
                  action :delete
                  bs_label 'test name#0 data'
                  project 'test project#0 data'
                  credential 'mycred'
                end
              MANIFEST
            ) do |recipe_name|
              runner.converge(recipe_name) do
                cred = Google::CredentialResourceMock.new('mycred',
                                                          runner.run_context)
                runner.resource_collection.insert(cred)
              end
            end
          end

          subject do
            chef_run.find_resource(:gcompute_backend_service, 'title0')
          end

          it 'should run test correctly' do
            expect(chef_run).to delete(:gcompute_backend_service,
                                       'title0')
          end
        end

        # Ensure absent: resource exists, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(alexstephen): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end
  end

  def expand_variables(template, data, extra_data = {})
    Google::GCOMPUTE::BackendService
      .action_class.expand_variables(template, data, extra_data)
  end

  def expect_network_get_success(id, data = {})
    id_data = data.fetch(:name, '').include?('title') ? 'title' : 'name'
    body = load_network_result("success#{id}~#{id_data}.yaml").to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! GET #{self_link(uri_data(id).merge(data))}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET #{args}"
      request
    end
  end

  def http_success(body)
    response = Net::HTTPOK.new(1.0, 200, 'OK')
    response.body = body
    response.instance_variable_set(:@read, true)
    response
  end

  def expect_network_get_async(id, data = {})
    body = { kind: 'compute#backendService' }.to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! #{self_link(uri_data(id).merge(data))}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET <async> #{args}"
      request
    end
  end

  def expect_network_get_failed(id, data = {})
    request = double('request')
    allow(request).to receive(:send).and_return(http_failed_object_missing)

    debug_network "!! #{self_link(uri_data(id).merge(data))}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET [failed] #{args}"
      request
    end
  end

  def http_failed_object_missing
    Net::HTTPNotFound.new(1.0, 404, 'Not Found')
  end

  def expect_network_create(id, expected_body, data = {})
    merged_uri = uri_data(id).merge(data)
    body = { kind: 'compute#operation',
             status: 'DONE', targetLink: self_link(merged_uri) }.to_json

    # Remove refs that are also part of the body
    expected_body = Hash[expected_body.map do |k, v|
      [k.is_a?(Symbol) ? k.id2name : k, v]
    end]

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! POST #{collection(merged_uri)}"
    expect(Google::Compute::Network::Post).to receive(:new)
      .with(collection(merged_uri), instance_of(Google::FakeAuthorization),
            'application/json', expected_body.to_json) do |args|
      debug_network ">> POST #{args} = body(#{body})"
      request
    end
  end

  def expect_network_delete(id, name = nil, data = {})
    delete_data = uri_data(id).merge(data)
    delete_data[:name] = name unless name.nil?
    body = { kind: 'compute#operation',
             status: 'DONE',
             targetLink: self_link(delete_data) }.to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! DELETE #{self_link(delete_data)}"
    expect(Google::Compute::Network::Delete).to receive(:new)
      .with(self_link(delete_data),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> DELETE #{args}"
      request
    end
  end

  def load_network_result(file)
    results = File.join(File.dirname(__FILE__), 'data', 'network',
                        'gcompute_backend_service', file)
    debug("Loading result file: #{results}")
    raise "Network result data file #{results}" unless File.exist?(results)
    data = YAML.safe_load(File.read(results))
    raise "Invalid network results #{results}" unless data.class <= Hash
    data
  end

  def expect_network_get_success_instance_group(id, data = {})
    id_data = data.fetch(:name, '').include?('title') ? 'title' : 'name'
    body = load_network_result_instance_group("success#{id}~" \
                                                           "#{id_data}.yaml")
           .to_json
    uri = uri_data_instance_group(id).merge(data)

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! GET #{uri}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link_instance_group(uri),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET #{args}"
      request
    end
  end

  def load_network_result_instance_group(file)
    results = File.join(File.dirname(__FILE__), 'data', 'network',
                        'gcompute_instance_group', file)
    raise "Network result data file #{results}" unless File.exist?(results)
    data = YAML.safe_load(File.read(results))
    raise "Invalid network results #{results}" unless data.class <= Hash
    data
  end

  # Creates variable test data to comply with self_link URI parameters
  # Only used for gcompute_instance_group objects
  def uri_data_instance_group(id)
    {
      project: GoogleTests::Constants::IG_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::IG_PROJECT_DATA.size],
      zone: GoogleTests::Constants::IG_ZONE_DATA[(id - 1) \
        % GoogleTests::Constants::IG_ZONE_DATA.size],
      name: GoogleTests::Constants::IG_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::IG_NAME_DATA.size]
    }
  end

  def self_link_instance_group(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables_instance_group(
        'projects/{{project}}/zones/{{zone}}/instanceGroups/{{name}}',
        data
      )
    )
  end

  def expect_network_get_success_zone(id, data = {})
    id_data = data.fetch(:name, '').include?('title') ? 'title' : 'name'
    body = load_network_result_zone("success#{id}~" \
                                                           "#{id_data}.yaml")
           .to_json
    uri = uri_data_zone(id).merge(data)

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! GET #{uri}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link_zone(uri),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET #{args}"
      request
    end
  end

  def load_network_result_zone(file)
    results = File.join(File.dirname(__FILE__), 'data', 'network',
                        'gcompute_zone', file)
    raise "Network result data file #{results}" unless File.exist?(results)
    data = YAML.safe_load(File.read(results))
    raise "Invalid network results #{results}" unless data.class <= Hash
    data
  end

  # Creates variable test data to comply with self_link URI parameters
  # Only used for gcompute_zone objects
  def uri_data_zone(id)
    {
      project: GoogleTests::Constants::Z_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::Z_PROJECT_DATA.size],
      name: GoogleTests::Constants::Z_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::Z_NAME_DATA.size]
    }
  end

  def self_link_zone(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables_zone(
        'projects/{{project}}/zones/{{name}}',
        data
      )
    )
  end

  def expect_network_get_success_region(id, data = {})
    id_data = data.fetch(:name, '').include?('title') ? 'title' : 'name'
    body = load_network_result_region("success#{id}~" \
                                                           "#{id_data}.yaml")
           .to_json
    uri = uri_data_region(id).merge(data)

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! GET #{uri}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link_region(uri),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET #{args}"
      request
    end
  end

  def load_network_result_region(file)
    results = File.join(File.dirname(__FILE__), 'data', 'network',
                        'gcompute_region', file)
    raise "Network result data file #{results}" unless File.exist?(results)
    data = YAML.safe_load(File.read(results))
    raise "Invalid network results #{results}" unless data.class <= Hash
    data
  end

  # Creates variable test data to comply with self_link URI parameters
  # Only used for gcompute_region objects
  def uri_data_region(id)
    {
      project: GoogleTests::Constants::R_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::R_PROJECT_DATA.size],
      name: GoogleTests::Constants::R_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::R_NAME_DATA.size]
    }
  end

  def self_link_region(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables_region(
        'projects/{{project}}/regions/{{name}}',
        data
      )
    )
  end

  def debug(message)
    puts(message) if ENV['RSPEC_DEBUG']
  end

  def debug_network(message)
    puts("Network #{message}") \
      if ENV['RSPEC_DEBUG'] || ENV['RSPEC_HTTP_VERBOSE']
  end

  def expand_variables_instance_group(template, data, ext_dat = {})
    Google::GCOMPUTE::InstanceGroup
      .action_class.expand_variables(template, data, ext_dat)
  end

  def expand_variables_zone(template, data, ext_dat = {})
    Google::GCOMPUTE::Zone
      .action_class.expand_variables(template, data, ext_dat)
  end

  def expand_variables_region(template, data, ext_dat = {})
    Google::GCOMPUTE::Region
      .action_class.expand_variables(template, data, ext_dat)
  end

  def collection(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables(
        'projects/{{project}}/global/backendServices',
        data
      )
    )
  end

  def self_link(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables(
        'projects/{{project}}/global/backendServices/{{name}}',
        data
      )
    )
  end

  # Creates variable test data to comply with self_link URI parameters
  def uri_data(id)
    {
      project: GoogleTests::Constants::BS_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::BS_PROJECT_DATA.size],
      name: GoogleTests::Constants::BS_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::BS_NAME_DATA.size]
    }
  end

  def build_cred
    <<-CRED
    gauth_credential 'mycred' do
      action :serviceaccount
      path '/home'
      scopes [
        'test_path'
      ]
    end
    CRED
  end

  # Creates a test recipe file and runs a block before destroying the file
  def apply_recipe(recipe)
    # Creates a random string name
    recipe_name = "recipe~test~#{(0...8).map { (65 + rand(26)).chr }.join}"
    recipe_loc = File.join(File.dirname(__FILE__), '..', 'recipes',
                           "#{recipe_name}.rb")

    File.open(recipe_loc, 'w') do |file|
      file.write([build_cred, recipe].join("\n"))
    end
    recipe_path = "google-gcompute::#{recipe_name}"
    begin
      yield recipe_path
    ensure
      File.delete(recipe_loc)
    end
  end
end
